various improvements and fixes, some flidas related
[distro-setup] / distro-begin
1 #!/bin/bash -l
2 # Copyright (C) 2016 Ian Kelling
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16
17
18
19 # for bootstrapping a new machine
20
21 # in case we need it,
22 # to make ssh interactive shell run better, we run this first.
23 sudo bash -c 'source /a/c/.bashrc && source /a/exe/ssh-emacs-setup'
24
25
26 # usage: $0 [-r] HOSTNAME
27
28 # tips:
29 # run any sudo command first so your pass is cached
30 # set the scrollback to unlimited in case something goes wrong
31
32 if [[ $EUID == 0 ]]; then
33 if getent passwd iank || getent passwd ian ; then
34 echo "$0: error: running as root. unprivileged user exists. use it."
35 exit 1
36 else
37 echo "$0: warning: running as root. I will setup users then exit"
38 fi
39 fi
40
41 interactive=true # set this to false to force set -x
42 [[ $- == *i* ]] || interactive=false
43
44 if ! $interactive; then
45 set -x
46 set -e -o pipefail
47 fi
48 set -E
49 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
50
51 exec &> >(sudo tee -a /var/log/distro-begin)
52 echo "$0: $(date): starting now)"
53
54 # headless=false # unused atm
55 recompile=false
56 # for copying to a new data fs
57 bootstrapfs=false # old flag, needs new look before using.
58 while [[ $1 == -* ]]; do
59 case $1 in
60 -r) recompile=true; shift ;;
61 esac
62 done
63
64 if [[ $1 ]]; then
65 export HOSTNAME=$1
66 fi
67
68 for f in iank-dev htpc treetowl x2 frodo tp li lj demohost kw; do
69 eval "$f() { [[ $HOSTNAME == $f ]]; }"
70 done
71 has_p() { ! linode; } # when tp is tracis, then not tp either
72 has_x() { ! linode; }
73 linode() { lj || li; }
74 has_btrfs() { ! linode; }
75 home_network() { ! linode; }
76 encrypted() { has_p; }
77
78 shopt -s extglob
79 export GLOBIGNORE=*/.:*/..
80 umask 0002
81
82
83 ####### end command line parsing
84
85 PATH="/a/exe:$PATH"
86 sed="sed --follow-symlinks"
87
88 ##### begin setup encryption scripts ######
89 if encrypted; then
90 # I tried making a service which was dependent on reboot.target,
91 # but it happened too late in the shutdown process.
92 sudo dd of=/etc/systemd/system/keyscripton.service <<'EOF'
93 [Unit]
94 Description=Turn on automatic decryption of drives on boot
95 # tried using graphical.target, but it made my display manager restart before rebooting.
96 # generally, I don't think targets order shutdown like they do startup.
97 # So, I did systemd-analyze plot > something.svg, and picked a reliably started
98 # service that happens late in the game.
99 After=ntp.service
100 DefaultDependencies=no
101 # not sure if needed, makes sure we shut down before reboot.target
102 Conflicts=reboot.target
103
104 [Service]
105 Type=oneshot
106 RemainAfterExit=yes
107 ExecStart=/bin/true
108 ExecStop=/a/exe/keyscript-on
109
110 [Install]
111 WantedBy=keyscriptoff.service
112 EOF
113 sudo systemctl daemon-reload # needed if the file was already there
114 sudo systemctl stop keyscripton.service
115 # sudo systemctl start keyscripton.service
116 sudo systemctl enable keyscripton.service
117
118 sudo dd of=/etc/systemd/system/keyscriptoff.service <<'EOF'
119 [Unit]
120 Description=Turn off automatic decryption of drives on boot
121
122 [Service]
123 Type=oneshot
124 ExecStart=/a/exe/keyscript-off
125
126 [Install]
127 WantedBy=multi-user.target
128 EOF
129 sudo systemctl daemon-reload # needed if the file was already there
130 sudo systemctl enable keyscriptoff.service
131 sudo systemctl start keyscriptoff.service
132 fi
133 ##### end setup encryption scripts ######
134
135
136 install-myqueue
137
138 # this script has been designed to be idempotent
139 # todo, it would be nice to cut down on some of the output
140
141
142 for x in /a/bin/errhandle/*-function; do
143 source $x
144 done
145
146
147 set +e
148 $interactive || errcatch
149 set +x
150 source /a/bin/distro-functions/src/identify-distros
151 $interactive || set -x
152
153 if isfedora; then
154 # comment out line disallowing calling sudo in scripts
155 sudo $sed -i 's/^Defaults *requiretty/#\0 # ian commented/' /etc/sudoers
156 # turn on magic sysrq commands for this boot cycle
157 echo 1 > sudo dd of=/proc/sys/kernel/sysrq
158 echo "kernel.sysrq = 1" > /etc/sysctl.d/90-sysrq.conf
159 # selinux is not user friendly. Like, you enable samba, but you haven't run the magic selinux commands so it doesn't work
160 # and you have no idea why.
161 sudo $sed -i 's/^\(SELINUX=\).*/\1disabled/' /etc/selinux/config
162 selinuxenabled && sudo setenforce 0
163 fi
164
165
166 # already ran for pxe installs, but used for vps & updates
167 distro=$(distro-name)
168 case $distro in
169 ubuntu|debian|trisquel)
170 sudo bash -c ". /a/bin/fai/fai-wrapper && /a/bin/fai/fai/config/scripts/GRUB_PC/11-iank"
171 ;;
172 *)
173 sudo bash -c ". /a/bin/fai/fai-wrapper &&
174 /a/bin/fai/fai/config/distro-install-common/end"
175 ;;
176 esac
177
178 sudo $sed -i '/^127\.0\.1\.1/d' /etc/hosts
179 echo "127.0.1.1 $HOSTNAME.b8.nz $HOSTNAME" | sudo tee -a /etc/hosts
180
181
182 if [[ $EUID == 0 ]]; then
183 echo "$0: running as root. exiting now that users are setup"
184 exit 0
185 fi
186
187
188 #### begin link bashrc for root ######
189 for x in /a/c/{.bashrc,brc,.bash_profile,.profile,.inputrc,path_add_function}; do
190 sudo -i <<EOF
191 PATH="/a/exe:$PATH"
192 lnf $x /root
193 EOF
194 done
195 #### end link bashrc repo for root ######
196
197 # li needs the bind group before conflink
198 if [[ $HOSTNAME == li ]]; then
199 getent group bind &>/dev/null || sudo groupadd -r bind
200 fi
201 # this needs to be before installing pacserve so we have gpg conf.
202 conflink
203
204 set +x
205 errallow
206 source /etc/profile.d/environment.sh
207 source ~/.bashrc
208 $interactive || errcatch
209 $interactive || set -x
210
211
212 # passwordless sudo
213 tu /etc/sudoers <<EOF
214 $USER ALL=(ALL) NOPASSWD: ALL
215 Defaults env_keep += SUDOD
216 # makes ubuntu be like debian
217 # https://unix.stackexchange.com/a/91572
218 Defaults always_set_home
219 EOF
220
221
222 # enable magic sysrq keys. debian docs say it is already enabled by default
223 isfedora && tu /etc/sysctl.conf 'kernel.sysrq = 1'
224
225
226 if isdeb; then
227 codename=$(debian-codename)
228 ## ian: disabled. backports are not being published atm due to rust packaging issue
229 # if isdebian-stable && has_x; then
230 # s dd of=/etc/apt/sources.list.d/mozilla-iceweasel.list <<EOF
231 # deb http://mozilla.debian.net/ $codename-backports firefox-release
232 # deb-src http://mozilla.debian.net/ $codename-backports firefox-release
233 # EOF
234 # p update
235 # # take care of mozilla signing errors in previous command
236 # pi pkg-mozilla-archive-keyring
237 # fi
238 p update
239
240 fi
241
242
243 ###### begin arch aur wrapper ########
244 if isarch; then
245 #https://wiki.archlinux.org/index.php/Arch_User_Repository#Installing_packages
246 sudo pacman -S --noconfirm --needed base-devel jq
247 # pacaur seems to be the best, although it + cower has a few minor bugs,
248 # its design goals seem good, so, going for it.
249
250 aurpi() {
251 for p in "$@"; do
252 tempdir=$(mktemp -d)
253 pushd $tempdir
254 aurex "$p"
255 makepkg -sri --skippgpcheck --noconfirm
256 popd
257 rm -rf $tempdir
258 done
259 }
260 aurpi cower pacaur
261
262 pi pacserve
263
264 x=$(mktemp); /usr/bin/pacman.conf-insert_pacserve >$x
265 sudo dd of=/etc/pacman.conf if=$x; rm $x
266 sudo systemctl enable pacserve.service
267 sudo systemctl start pacserve.service
268
269 fi
270 ###### end arch aur wrapper ########
271
272 pup
273
274
275 ###### begin trash cli install ######
276 if isarch; then
277 # strange error if just installing trash-cli: "pyalpm requires python",
278 # so I see that it requires python2, and installing that manually fixes it.
279 # I didn\'t see this on earlier installation, main thing which changed was
280 # pacserve, so not sure if it\'s related.
281 pi python2
282 fi
283 pi trash-cli
284 ###### end trash cli install ######
285
286
287 ######## begin fix evbug bug ######
288 case $distro in
289 trisquel|ubuntu)
290 # noticed in flidas.
291 #https://bugs.launchpad.net/ubuntu/+source/module-init-tools/+bug/240553
292 sudo rmmod evbug ||: # might not be loaded yet
293 file=/etc/modprobe.d/blacklist.conf
294 line="blacklist evbug"
295 if ! grep -xFq "$line" $file; then
296 sudo tee -a $file &>/dev/null <<<"$line"
297 sudo depmod -a
298 sudo update-initramfs -u
299 fi
300 ;;
301 esac
302 ######## end fix evbug bug ######
303
304
305
306 ###### begin link files ###########
307 # convenient to just do all file linking in one place
308
309
310 s lnf -T /a/bin /b
311 s lnf -T /nocow/t /t
312
313 if has_p; then
314 lnf -T /p/News ~/News
315 fi
316
317 s lnf /q/root/.editor-backups /q/root/.undo-tree-history \
318 /a/opt /a/c/.emacs.d $HOME/mw_vars /k/backup /root
319
320 rootsshsync
321
322 s lnf /a/c/.vim /a/c/.vimrc /a/c/.gvimrc /root
323
324 # machine is going away
325 # if [[ $HOSTNAME == htpc ]]; then
326 # lnf -T /i/Videos ~/Downloads
327 # fi
328
329 if has_p; then
330 # for dovecot
331 lnf -T /i/k/mboxes ~/mail
332 fi
333
334 ###### end link files ###########
335
336
337 ##### basic needed packages
338
339 ### begin setup for keyboard and redshift ###
340 case $(distro-name) in
341
342 trisquel|ubuntu|debian)
343 if has_x; then
344 if isdebian-testing; then
345 pi xmacro/unstable # has no unstable deps
346 else
347 pi xmacro
348 fi
349 pi gtk-redshift xinput
350 fi
351 ;;&
352 fedora)
353 p -y groupinstall development-tools c-development books admin-tools
354 pi wget man-pages
355 if has_x; then
356 pi redshift-gtk
357 # debian has this package patched to work, upstream is dead
358 # tried using alien, pi alien, alien -r *.deb, rpm -Uhv *.rpm, got this error, so fuck it
359 # file /usr/bin from install of xmacro-0.3pre_20000911-7.x86_64 conflicts with file from package filesystem-3.2-19.fc20.x86_64
360 # http://packages.debian.org/source/sid/xmacro
361 pi patch libXtst-devel
362 cd $(mktemp -d)
363 wget http://ftp.de.debian.org/debian/pool/main/x/xmacro/xmacro_0.3pre-20000911.orig.tar.gz
364 wget http://ftp.de.debian.org/debian/pool/main/x/xmacro/xmacro_0.3pre-20000911-6.diff.gz
365 ex *.gz
366 patch -p0 < xmacro_0.3pre-20000911-6.diff
367 cd xmacro-0.3pre-20000911.orig
368 make
369 sleep 1 # not sure why the following command couldn\'t find, so trying this
370 # no make install target
371 s cp -f xmacroplay xmacrorec xmacrorec2 /usr/local/bin
372 fi
373 ;;&
374 arch)
375 # like apt-cache
376 pi pkgfile
377 s pkgfile --update
378 if has_x; then
379 # libxtst is missing dep https://aur.archlinux.org/packages/xmacro/#news
380 pi xorg-server redshift xorg-xinput libxtst xmacro
381
382 # background:
383 # https://aur.archlinux.org/packages/xkbset/#comment-545419
384 cert=$(mktemp)
385 cat >$cert <<'EOF'
386 -----BEGIN CERTIFICATE-----
387 MIIJADCCB+igAwIBAgIRAIVAhZ0TMbQ5jTm0koI8X6YwDQYJKoZIhvcNAQELBQAw
388 djELMAkGA1UEBhMCVVMxCzAJBgNVBAgTAk1JMRIwEAYDVQQHEwlBbm4gQXJib3Ix
389 EjAQBgNVBAoTCUludGVybmV0MjERMA8GA1UECxMISW5Db21tb24xHzAdBgNVBAMT
390 FkluQ29tbW9uIFJTQSBTZXJ2ZXIgQ0EwHhcNMTUxMjA4MDAwMDAwWhcNMTgxMjA3
391 MjM1OTU5WjCBsTELMAkGA1UEBhMCVVMxDjAMBgNVBBETBTY1MjExMREwDwYDVQQI
392 EwhNaXNzb3VyaTERMA8GA1UEBxMIQ29sdW1iaWExHzAdBgNVBAkTFjExMDAgQ2Fy
393 cmllIEZyYW5ja2UgRHIxHzAdBgNVBAoTFlVuaXZlcnNpdHkgb2YgTWlzc291cmkx
394 CzAJBgNVBAsTAk1VMR0wGwYDVQQDExRmYWN1bHR5Lm1pc3NvdXJpLmVkdTCCASIw
395 DQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAN8Kap8hASpxQeqjHibGsCR1PBkh
396 nW9p5FkuhGpMW/3ko8QfxH0W1Hq2y2DTFUmq17kH3GfT3h9a7HcmUrC3q15PciOB
397 WR3j8u0bDfVppyAZXiHJzYGN7xHiPrZtFEGgwZd28+sW80WXTbGl+zKkmeZguGdH
398 AVGeWJEFK44ctLbpjHWCy+xNuhxJuL4olwPoV7WX9IUhceC0rxYQANhLGOJhbchj
399 Z76MA8dc2K3CZI5m7VqQwl09QSnCfz00afUr88ny9vj1S5k2ADS46gaE9O0lM6EY
400 z/uZvMizXN/4ko+hFBjCSt0Vhxjx0kYDSP15btiwh700ywBEubpvLROmd48CAwEA
401 AaOCBUswggVHMB8GA1UdIwQYMBaAFB4Fo3ePbJbiW4dLprSGrHEADOc4MB0GA1Ud
402 DgQWBBTTNWrSb+V/Ayy0i8W2LExMUisQMzAOBgNVHQ8BAf8EBAMCBaAwDAYDVR0T
403 AQH/BAIwADAdBgNVHSUEFjAUBggrBgEFBQcDAQYIKwYBBQUHAwIwZwYDVR0gBGAw
404 XjBSBgwrBgEEAa4jAQQDAQEwQjBABggrBgEFBQcCARY0aHR0cHM6Ly93d3cuaW5j
405 b21tb24ub3JnL2NlcnQvcmVwb3NpdG9yeS9jcHNfc3NsLnBkZjAIBgZngQwBAgIw
406 RAYDVR0fBD0wOzA5oDegNYYzaHR0cDovL2NybC5pbmNvbW1vbi1yc2Eub3JnL0lu
407 Q29tbW9uUlNBU2VydmVyQ0EuY3JsMHUGCCsGAQUFBwEBBGkwZzA+BggrBgEFBQcw
408 AoYyaHR0cDovL2NydC51c2VydHJ1c3QuY29tL0luQ29tbW9uUlNBU2VydmVyQ0Ff
409 Mi5jcnQwJQYIKwYBBQUHMAGGGWh0dHA6Ly9vY3NwLnVzZXJ0cnVzdC5jb20wggOg
410 BgNVHREEggOXMIIDk4IUZmFjdWx0eS5taXNzb3VyaS5lZHWCGmFkdmlzaW5nLmNv
411 YXMubWlzc291cmkuZWR1ghBhaGEubWlzc291cmkuZWR1ghZhbGwtY3JhZnQubWlz
412 c291cmkuZWR1gh1hbWVyaWNhbmJhc2tldHJ5Lm1pc3NvdXJpLmVkdYIXYW5kcmVh
413 cmlldy5taXNzb3VyaS5lZHWCFWFydGdyYWRzLm1pc3NvdXJpLmVkdYIYYmFja3Vw
414 LmNvYXMubWlzc291cmkuZWR1ghBiaWMubWlzc291cmkuZWR1ghZibG9nLmNvYXMu
415 bWlzc291cmkuZWR1ghVjb3dhbmxhYi5taXNzb3VyaS5lZHWCFWRhZS5zdGF0Lm1p
416 c3NvdXJpLmVkdYIRZGljZS5taXNzb3VyaS5lZHWCIGRpZ2l0YWxzdG9yeXRlbGxp
417 bmcubWlzc291cmkuZWR1gg9lYS5taXNzb3VyaS5lZHWCG2Vib29rLWRldi5tYXRo
418 Lm1pc3NvdXJpLmVkdYIXZWJvb2suZWNvbi5taXNzb3VyaS5lZHWCGGVuZ2xpc2g4
419 MDA2Lm1pc3NvdXJpLmVkdYIZZXVnZW5lZml0c2NoLm1pc3NvdXJpLmVkdYIYZXVy
420 b2t1bHR1cmUubWlzc291cmkuZWR1ghNmY2RsYWIubWlzc291cmkuZWR1ghZnZW9t
421 dXNldW0ubWlzc291cmkuZWR1ghRoYXJzdGFkLm1pc3NvdXJpLmVkdYITbHVkd2ln
422 Lm1pc3NvdXJpLmVkdYIYbWFjaGluZXNob3AubWlzc291cmkuZWR1ghNtYWpvcnMu
423 bWlzc291cmkuZWR1ghBtZ2EubWlzc291cmkuZWR1ghdvcmdhbnByaW50Lm1pc3Nv
424 dXJpLmVkdYIUcGh5c2ljcy5taXNzb3VyaS5lZHWCFHBtLmNoZW0ubWlzc291cmku
425 ZWR1ghxyZWNydWl0aW5nLmVjb24ubWlzc291cmkuZWR1ghdyZXBlYy5lY29uLm1p
426 c3NvdXJpLmVkdYIUc2NhbmxhYi5taXNzb3VyaS5lZHWCFnNzc2MuY29hcy5taXNz
427 b3VyaS5lZHWCF3RlYWNoLmNvYXMubWlzc291cmkuZWR1ghd0b3B0ZWFjaGVyLm1p
428 c3NvdXJpLmVkdYIQdnNmLm1pc3NvdXJpLmVkdYIid2hpdGVwYXBlci5ncmFkc2No
429 b29sLm1pc3NvdXJpLmVkdTANBgkqhkiG9w0BAQsFAAOCAQEAQutYVAqG7MpmG2Nu
430 Z/UypjYkN4JvwRbKBpTrce2IT/Sy29x6chBbyD+0WE6QORBtaUHuzE1KoXqpnF4M
431 QrkKw0oBAC6x9dISoomq0DkIndtoBYYLaxSoII6F4OGWgF7pQ/7MiCBYzsKQpn9t
432 aofMcTfvnCjq+MCIaeYnUKBVww0lOJlUxZGKxFJvRpf78HfbBauojjRO2zXLZD/u
433 KMspbTfDaj5etIgWGShY2eml3N/SjAENmZYkcgDBYFyi8CckcEBAVzpH1+D+7Anz
434 txHSYDNHAYLv83MwbegApa1FwPqlG/4SdEU8G6e6Xf5GLC/6GPGVTUpr7o348OOO
435 lzGQzw==
436 -----END CERTIFICATE-----
437 -----BEGIN CERTIFICATE-----
438 MIIF+TCCA+GgAwIBAgIQRyDQ+oVGGn4XoWQCkYRjdDANBgkqhkiG9w0BAQwFADCB
439 iDELMAkGA1UEBhMCVVMxEzARBgNVBAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0pl
440 cnNleSBDaXR5MR4wHAYDVQQKExVUaGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNV
441 BAMTJVVTRVJUcnVzdCBSU0EgQ2VydGlmaWNhdGlvbiBBdXRob3JpdHkwHhcNMTQx
442 MDA2MDAwMDAwWhcNMjQxMDA1MjM1OTU5WjB2MQswCQYDVQQGEwJVUzELMAkGA1UE
443 CBMCTUkxEjAQBgNVBAcTCUFubiBBcmJvcjESMBAGA1UEChMJSW50ZXJuZXQyMREw
444 DwYDVQQLEwhJbkNvbW1vbjEfMB0GA1UEAxMWSW5Db21tb24gUlNBIFNlcnZlciBD
445 QTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAJwb8bsvf2MYFVFRVA+e
446 xU5NEFj6MJsXKZDmMwysE1N8VJG06thum4ltuzM+j9INpun5uukNDBqeso7JcC7v
447 HgV9lestjaKpTbOc5/MZNrun8XzmCB5hJ0R6lvSoNNviQsil2zfVtefkQnI/tBPP
448 iwckRR6MkYNGuQmm/BijBgLsNI0yZpUn6uGX6Ns1oytW61fo8BBZ321wDGZq0GTl
449 qKOYMa0dYtX6kuOaQ80tNfvZnjNbRX3EhigsZhLI2w8ZMA0/6fDqSl5AB8f2IHpT
450 eIFken5FahZv9JNYyWL7KSd9oX8hzudPR9aKVuDjZvjs3YncJowZaDuNi+L7RyML
451 fzcCAwEAAaOCAW4wggFqMB8GA1UdIwQYMBaAFFN5v1qqK0rPVIDh2JvAnfKyA2bL
452 MB0GA1UdDgQWBBQeBaN3j2yW4luHS6a0hqxxAAznODAOBgNVHQ8BAf8EBAMCAYYw
453 EgYDVR0TAQH/BAgwBgEB/wIBADAdBgNVHSUEFjAUBggrBgEFBQcDAQYIKwYBBQUH
454 AwIwGwYDVR0gBBQwEjAGBgRVHSAAMAgGBmeBDAECAjBQBgNVHR8ESTBHMEWgQ6BB
455 hj9odHRwOi8vY3JsLnVzZXJ0cnVzdC5jb20vVVNFUlRydXN0UlNBQ2VydGlmaWNh
456 dGlvbkF1dGhvcml0eS5jcmwwdgYIKwYBBQUHAQEEajBoMD8GCCsGAQUFBzAChjNo
457 dHRwOi8vY3J0LnVzZXJ0cnVzdC5jb20vVVNFUlRydXN0UlNBQWRkVHJ1c3RDQS5j
458 cnQwJQYIKwYBBQUHMAGGGWh0dHA6Ly9vY3NwLnVzZXJ0cnVzdC5jb20wDQYJKoZI
459 hvcNAQEMBQADggIBAC0RBjjW29dYaK+qOGcXjeIT16MUJNkGE+vrkS/fT2ctyNMU
460 11ZlUp5uH5gIjppIG8GLWZqjV5vbhvhZQPwZsHURKsISNrqOcooGTie3jVgU0W+0
461 +Wj8mN2knCVANt69F2YrA394gbGAdJ5fOrQmL2pIhDY0jqco74fzYefbZ/VS29fR
462 5jBxu4uj1P+5ZImem4Gbj1e4ZEzVBhmO55GFfBjRidj26h1oFBHZ7heDH1Bjzw72
463 hipu47Gkyfr2NEx3KoCGMLCj3Btx7ASn5Ji8FoU+hCazwOU1VX55mKPU1I2250Lo
464 RCASN18JyfsD5PVldJbtyrmz9gn/TKbRXTr80U2q5JhyvjhLf4lOJo/UzL5WCXED
465 Smyj4jWG3R7Z8TED9xNNCxGBMXnMete+3PvzdhssvbORDwBZByogQ9xL2LUZFI/i
466 eoQp0UM/L8zfP527vWjEzuDN5xwxMnhi+vCToh7J159o5ah29mP+aJnvujbXEnGa
467 nrNxHzu+AGOePV8hwrGGG7hOIcPDQwkuYwzN/xT29iLp/cqf9ZhEtkGcQcIImH3b
468 oJ8ifsCnSbu0GB9L06Yqh7lcyvKDTEADslIaeSEINxhO2Y1fmcYFX/Fqrrp1WnhH
469 OjplXuXE0OPa0utaKC25Aplgom88L2Z8mEWcyfoB7zKOfD759AN7JKZWCYwk
470 -----END CERTIFICATE-----
471 -----BEGIN CERTIFICATE-----
472 MIIF3jCCA8agAwIBAgIQAf1tMPyjylGoG7xkDjUDLTANBgkqhkiG9w0BAQwFADCB
473 iDELMAkGA1UEBhMCVVMxEzARBgNVBAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0pl
474 cnNleSBDaXR5MR4wHAYDVQQKExVUaGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNV
475 BAMTJVVTRVJUcnVzdCBSU0EgQ2VydGlmaWNhdGlvbiBBdXRob3JpdHkwHhcNMTAw
476 MjAxMDAwMDAwWhcNMzgwMTE4MjM1OTU5WjCBiDELMAkGA1UEBhMCVVMxEzARBgNV
477 BAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0plcnNleSBDaXR5MR4wHAYDVQQKExVU
478 aGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNVBAMTJVVTRVJUcnVzdCBSU0EgQ2Vy
479 dGlmaWNhdGlvbiBBdXRob3JpdHkwggIiMA0GCSqGSIb3DQEBAQUAA4ICDwAwggIK
480 AoICAQCAEmUXNg7D2wiz0KxXDXbtzSfTTK1Qg2HiqiBNCS1kCdzOiZ/MPans9s/B
481 3PHTsdZ7NygRK0faOca8Ohm0X6a9fZ2jY0K2dvKpOyuR+OJv0OwWIJAJPuLodMkY
482 tJHUYmTbf6MG8YgYapAiPLz+E/CHFHv25B+O1ORRxhFnRghRy4YUVD+8M/5+bJz/
483 Fp0YvVGONaanZshyZ9shZrHUm3gDwFA66Mzw3LyeTP6vBZY1H1dat//O+T23LLb2
484 VN3I5xI6Ta5MirdcmrS3ID3KfyI0rn47aGYBROcBTkZTmzNg95S+UzeQc0PzMsNT
485 79uq/nROacdrjGCT3sTHDN/hMq7MkztReJVni+49Vv4M0GkPGw/zJSZrM233bkf6
486 c0Plfg6lZrEpfDKEY1WJxA3Bk1QwGROs0303p+tdOmw1XNtB1xLaqUkL39iAigmT
487 Yo61Zs8liM2EuLE/pDkP2QKe6xJMlXzzawWpXhaDzLhn4ugTncxbgtNMs+1b/97l
488 c6wjOy0AvzVVdAlJ2ElYGn+SNuZRkg7zJn0cTRe8yexDJtC/QV9AqURE9JnnV4ee
489 UB9XVKg+/XRjL7FQZQnmWEIuQxpMtPAlR1n6BB6T1CZGSlCBst6+eLf8ZxXhyVeE
490 Hg9j1uliutZfVS7qXMYoCAQlObgOK6nyTJccBz8NUvXt7y+CDwIDAQABo0IwQDAd
491 BgNVHQ4EFgQUU3m/WqorSs9UgOHYm8Cd8rIDZsswDgYDVR0PAQH/BAQDAgEGMA8G
492 A1UdEwEB/wQFMAMBAf8wDQYJKoZIhvcNAQEMBQADggIBAFzUfA3P9wF9QZllDHPF
493 Up/L+M+ZBn8b2kMVn54CVVeWFPFSPCeHlCjtHzoBN6J2/FNQwISbxmtOuowhT6KO
494 VWKR82kV2LyI48SqC/3vqOlLVSoGIG1VeCkZ7l8wXEskEVX/JJpuXior7gtNn3/3
495 ATiUFJVDBwn7YKnuHKsSjKCaXqeYalltiz8I+8jRRa8YFWSQEg9zKC7F4iRO/Fjs
496 8PRF/iKz6y+O0tlFYQXBl2+odnKPi4w2r78NBc5xjeambx9spnFixdjQg3IM8WcR
497 iQycE0xyNN+81XHfqnHd4blsjDwSXWXavVcStkNr/+XeTWYRUc+ZruwXtuhxkYze
498 Sf7dNXGiFSeUHM9h4ya7b6NnJSFd5t0dCy5oGzuCr+yDZ4XUmFF0sbmZgIn/f3gZ
499 XHlKYC6SQK5MNyosycdiyA5d9zZbyuAlJQG03RoHnHcAP9Dc1ew91Pq7P8yF1m9/
500 qS3fuQL39ZeatTXaw2ewh0qpKJ4jjv9cJ2vhsE/zB+4ALtRZh8tSQZXq9EfX7mRB
501 VXyNWQKV3WKdwrnuWih0hKWbt5DHDAff9Yk2dDLWKMGwsAvgnEzDHNb842m1R0aB
502 L6KCq9NjRHDEjf8tM7qtj3u1cIiuPhnPQCjY/MiQu12ZIvVS5ljFH4gxQ+6IHdfG
503 jjxDah2nGN59PRbxYvnKkKj9
504 -----END CERTIFICATE-----
505 EOF
506 cat /etc/ssl/certs/ca-certificates.crt >> $cert
507 CURL_CA_BUNDLE=$cert pi xkbset
508 fi
509
510 ;;&
511 ubuntu|trisquel|debian|fedora)
512 if has_x; then
513 if isdebian-testing; then
514 # xkbset was in testing for quite a while, dunno
515 # why it\'s not anymore. Sometime I should check and
516 # see if it\'s back in testing, but the unstable package
517 # doesn\'t upgrade anything form testing, and it\'s tiny
518 # so I\'m not bothering to automate it.
519 pi xkbset/unstable
520 else
521 pi xkbset
522 fi
523 fi
524 ;;&
525 esac
526 if has_x; then
527 pi xbindkeys
528 fi
529 ### end setup for keyboard and redshift ###
530
531
532 pi cryptsetup lvm2
533 # enables trim for volume delete, other rare commands.
534 sudo $sed -ri 's/( *issue_discards\b).*/\1 = 1/' /etc/lvm/lvm.conf
535
536 if encrypted; then
537 if isdeb; then
538 sudo cp /usr/share/doc/util-linux/examples/fstrim.{service,timer} /etc/systemd/system
539 fi
540 # does weekly trim
541 sudo systemctl enable fstrim.timer
542 fi
543
544 dirs=(/mnt/{1,2,3,4,5,6,7,8,9} /nocow/t)
545 s mkdir -p "${dirs[@]}"
546 s chown $USER:$USER "${dirs[@]}"
547
548
549 tu /etc/fstab <<'EOF'
550 /i/w /w none bind,noauto 0 0
551 /i/k /k none bind,noauto 0 0
552 EOF
553
554
555 if ! mountpoint /kr; then
556 s mkdir -p /kr
557 s chown $USER:traci /kr
558 fi
559
560 if home_network; then
561 if [[ $HOSTNAME == frodo ]]; then
562 tu /etc/fstab <<'EOF'
563 /k /kr none bind,noauto 0 0
564 EOF
565 else
566 tu /etc/fstab <<'EOF'
567 frodo:/k /kr nfs noauto 0 0
568 EOF
569 fi
570 fi
571
572 s mkdir -p /q /i/{w,k}
573 for dir in /{i,w,k}; do
574 if mountpoint $dir; then continue; fi # already mounted
575 s mkdir -p $dir
576 s chown $USER:$USER $dir
577 done
578
579 # not needed for all hosts, but rather just keep it uniform
580 s mkdir -p /mnt/iroot
581
582 # debian auto mounting of multi-disk encrypted btrfs is busted. It is
583 # in jessie, and in stretch as of 11/26/2016 I have 4 disks in cryptab,
584 # based on 3 of those, it creates .device units for /dev/mapper/dev...
585 # then waits endlessly for them on bootup, after the /dev/mapper disks
586 # have already been created and exist. todo: create a simple repro
587 # for this in a vm and report it upstream.
588 if has_btrfs || home_network; then
589 pi nfs-common
590 s dd of=/root/imount <<'EOF'
591 #!/bin/bash
592 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
593 set -eE -o pipefail
594 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
595 for dir in /i /mnt/iroot /k /kr /w; do
596 if ! mountpoint $dir &>/dev/null && \
597 awk '{print $2}' /etc/fstab | grep -xF $dir &>/dev/null; then
598 if awk '{print $3}' /etc/fstab | grep -xF nfs &>/dev/null; then
599 mount $dir || echo "warning: failed to mount nfs on $dir"
600 else
601 mount $dir
602 fi
603 fi
604 done
605 EOF
606 s chmod +x /root/imount
607
608 s dd of=/etc/systemd/system/imount.service <<EOF
609 [Unit]
610 Description=Mount /i and related mountpoints
611 Before=syncthing@$USER.service
612
613 [Service]
614 Type=oneshot
615 ExecStart=/root/imount
616
617 [Install]
618 RequiredBy=syncthing@$USER.service
619 # note /kr needs networking, this target is the simplest way to
620 # time it when the network should be up, but not do something
621 # dumb like delay startup until the network is up. It happens
622 # at some time after network.target
623 WantedBy=multi-user.target
624 EOF
625 sudo systemctl daemon-reload # needed if the file was already there
626 sudo systemctl enable imount.service
627 sudo systemctl start imount.service
628 fi
629
630 dir=/nocow
631 if has_btrfs; then
632 if ! mountpoint $dir; then
633 subvol=/mnt/root/nocow
634 if [[ ! -e $subvol ]]; then
635 s btrfs subvolume create $subvol
636 s chown root:1000 $subvol
637 s chattr +C $subvol
638 fi
639
640 first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
641 tu /etc/fstab <<EOF
642 $first_root_crypt /nocow btrfs noatime,subvol=nocow 0 0
643 EOF
644 s mkdir -p $dir
645 s chown $USER:$USER $dir
646 s mount $dir
647 fi
648 else
649 sudo mkdir -p $dir
650 fi
651
652 # ssh and probably some other things care about parent directory
653 # ownership, and ssh doesn\'t allow any group writable parent
654 # directories, so we are forced to use a directory structure similar
655 # to home directories
656 s chown root:$USER /q
657 s chmod 755 /q
658
659
660 # it comes with stretch and arch, but not jessie.
661 # propogate /etc/udev/hwdb.d
662 if which systemd-hwdb; then
663 s systemd-hwdb update
664 ser restart systemd-udev-trigger
665 fi
666
667
668 if isdeb; then
669 # I\'ve had problems with postfix on debian:
670 # on stretch, a startup ordering issue caused all mail to fail.
671 # postfix changed defaults to only use ipv6 dns, causing all my mail to fail.
672 # exim4 is default on debian, so I assume it would
673 # be packaged better to avoid these types of things.
674 # I haven\'t gotten around to getting a non-debian exim
675 # setup.
676 mail-setup exim4
677 else
678 mail-setup postfix
679 fi
680
681 if isubuntu; then
682 # disable crash report annoying dialogs.
683 s dd of=/etc/default/apport <<<'enabled=0'
684 fi
685
686 # fai sets this an old way that doesn't work for stretch.
687 # no harm in setting it universally here.
688 # using debconf-set-selection, the area gets reset to ETC
689 # on my linode test machine after doing a dpkg-reconfigure, or a reinstall,
690 # so we are using expect :(
691 # I got a random error when running this, so I added a sleep
692 # rather than trying to write a whole detect and wait loop.
693 # E: Could not get lock /var/lib/dpkg/lock - open (11: Resource temporarily unavailable)
694 # E: Unable to lock the administration directory (/var/lib/dpkg/), is another process using it?
695 sleep 1
696 # todo: this is not idempotent, it fails when running twice, due to prepopulated values.
697 # check into unsetting them using debconf-set-selection.
698 s apt-get -y install --no-install-recommends expect
699 s expect <<EOF ||:
700 set force_conservative 0
701 spawn dpkg-reconfigure tzdata -freadline
702 expect -nocase timeout {exit 1} "Geographic area:"
703 send "\02512\r"
704 expect -nocase timeout {exit 1} "Time zone:"
705 send "\0255\r"
706 expect eof
707 exit
708 EOF
709
710
711 if has_x; then
712 if isarch; then
713 # install so it's build dependencies don't get removed.
714
715 # emacs git build is currently broken
716 if false; then
717 x=$(mktemp -d)
718 pushd $x
719 aurex emacs-git
720 makepkg -si --noconfirm
721 popd
722 rm -rf $x
723 else
724 pi emacs
725 fi
726 pi hunspell hunspell-en
727 else
728 if $recompile; then
729 /a/bin/buildscripts/emacs
730 else
731 /a/bin/buildscripts/emacs --no-r || /a/bin/buildscripts/emacs
732 fi
733 fi
734
735 # todo, figure this out for arch if we ever try out gnome.
736 if ! isarch; then
737 # install for multiple display managers in case we use one
738 if isdeb; then
739 dir=/etc/gdm3
740 elif isfedora; then
741 # fedora didn\'t have the 3.
742 dir=/etc/gdm
743 fi
744 s mkdir -p $dir/PostLogin
745 s command cp /a/bin/distro-setup/desktop-20-autostart.sh $dir/PostLogin/Default
746 s mkdir /etc/lightdm/lightdm.conf.d
747 s dd of=/etc/lightdm/lightdm.conf.d/12-iank.conf <<'EOF'
748 [SeatDefaults]
749 session-setup-script=/a/bin/distro-setup/desktop-20-autostart.sh
750 EOF
751 fi
752
753
754 pi ghc sakura
755 # todo, also note for work comp, scp opt/org-mode bin/build-scripts
756
757 # use the package manger version to install the cabal version
758 pi cabal-install
759 cabal update
760 PATH="$PATH:$HOME/.cabal/bin"
761
762 # todo, on older ubuntu I used cabal xmonad + xfce,
763 # see /a/bin/old-unused/xmonad-cabal.sh
764
765 # trying out the distros versions newer distros
766 pi xmonad
767 if isarch; then
768 # for displaying error messages.
769 # optional dependency in arch, standard elsewhere.
770 pi xorg-xmessage xmonad-contrib xorg-xsetroot xorg-xinit
771
772 # https://wiki.archlinux.org/index.php/Xinitrc
773 for homedir in /home/*; do
774 cp /etc/X11/xinit/xinitrc $homedir/.xinitrc
775 $sed -ri '/^ *twm\b/,$d' $homedir/.xinitrc
776 tee -a $homedir/.xinitrc <<'EOF'
777 /a/bin/desktop-20-autostart.sh
778 xsetroot -cursor_name left_ptr
779 exec xmonad
780 EOF
781 done
782 else
783 pi suckless-tools
784 fi
785 pi dmenu
786
787 if tp || x2; then
788 case $distro in
789 debian)
790 pi task-laptop
791 ;;
792 ubuntu|trisquel)
793 # the exact packages that task-laptop would install, since ubuntu
794 # doesn\'t have this virtual in practice package.
795 pi avahi-autoipd bluetooth powertop iw wireless-tools wpasupplicant
796 ;;
797 # todo: other distros unknown
798 esac
799 fi
800 fi
801
802 # the first pup command can kill off our /etc/ mod, so rerun this
803 /a/exe/ssh-emacs-setup
804 echo "$0: $(date): ending now"
805 exit 0